// EV3操作用の関数
#include "ev3api.h"
#include "syssvc/serial.h"
#include "app.h"
//#include "control.h"

// Debug Message on LCD
void lcd_new_message(const char* msg) {
	ev3_lcd_fill_rect(0, 0, EV3_LCD_WIDTH, EV3_LCD_HEIGHT, EV3_LCD_WHITE);
	ev3_lcd_draw_string(msg, 10, EV3_LCD_HEIGHT / 2);
}

// フタを開ける(モータ-ID, フタを開けるために必要なモータの回転角度, フタを開けるスピード)
void openCover(void) {
	ev3_motor_rotate(cover_motor, COVER_OPEN_DEGREE, COVER_OPEN_SPEED, false);
}

// フタを閉じる
void closeCover(void) {
	ev3_motor_rotate(cover_motor, COVER_CLOSE_DEGREE, COVER_CLOSE_SPEED, false);
}

// ノズルを出す
void putOutNozzle(void) {
	ev3_motor_rotate(nozzle_motor, NOZZLE_DEGREE, NOZZLE_SPEED, true);
}

// ノズルをしまう
void putAwayNozzle(void) {
	ev3_motor_rotate(nozzle_motor, NOZZLE_OFF_DEGREE, NOZZLE_SPEED, true);
}

// ウォシュレットの水を出す
void openSplay(void) {
	ev3_motor_set_power(splay_motor, 50);
}

// ウォシュレットの水を止める
void closeSplay(void) {
	ev3_motor_set_power(splay_motor, 0);
}

// 洗浄水を流す（ブザー音で代替）
void openFlash(void) {
	ev3_speaker_play_tone(FLASH_SOUND, SOUND_MANUAL_STOP);
}

// 洗浄水を止める
void closeFlash(void) {
	ev3_speaker_stop();
}

// 着座判定
int chkSeated(const int reflect_min, const int reflect_max) {
	int reflect = ev3_color_sensor_get_reflect(seated_sensor);
	static char msg[100];
	sprintf(msg, "reflect: %d\r\n", reflect);
	(void)serial_wri_dat(SIO_PORT_BT, msg, sizeof(msg));
	if (reflect_min < reflect && reflect < reflect_max) {
		return 0;
	} else {
		return 1;
	}
}
